/*
 * HMG User Components Demo1
 * (c) 2006 Roberto Lopez
 *
 * Version 1.4
 *
 * Revised by Pablo César on April 6th, 2016
 *   - Added directives at i_UsrSOOP.ch
 *   - Created local directive i_UsrInit.ch
 *   - Added Width, Height and MULTINE at Button functions
 *   - MyButton.prg included at .hbp (project file)
 */

#include "hmg.ch"
#include "i_UsrInit.ch"

Function Main()
PRIVATE lVisible:=.T.

DEFINE WINDOW Form_1 AT 0,0 WIDTH 400 HEIGHT 250 ;
    TITLE 'Demo of Custom Button Control and User Properties' MAIN

    DEFINE MAIN MENU
        DEFINE POPUP 'Test Menu'
            MENUITEM 'Custom Method: Button Visible (On/Off)'  ACTION (lVisible:=If(lVisible,.F.,.T.),Form_1.Test.Visible:=lVisible)
            MENUITEM 'Custom Method: Print Form in default'    ACTION Form_1.Print
            MENUITEM 'Custom Method: Print() with Preview'     ACTION Form_1.Print()
            MENUITEM 'Custom Method: Disable'                  ACTION Form_1.Test.Disable
            MENUITEM 'Custom Method: Enable'                   ACTION Form_1.Test.Enable
            MENUITEM 'Custom Property: Handle (Get)'           ACTION MsgInfo ( Str ( Form_1.Test.Handle ), 'MyButton handle' )
            MENUITEM 'Custom Property: Handle (Set)'           ACTION Form_1.Test.Handle := 1
            MENUITEM 'Custom Property: Caption (Get)'          ACTION MsgInfo ( Form_1.Test.Caption, 'MyButton Caption' )
            MENUITEM 'Custom Property: Caption (Set)'          ACTION Form_1.Test.Caption := 'New Caption'
            MENUITEM 'Custom Property: Width and Height (Get)' ACTION MsgInfo ( 'Width: ' + AllTrim(Str( Form_1.Test.Width )) + ' / Height: ' + Alltrim(Str( Form_1.Test.Height )), 'MyButton Width & Height' )
        END POPUP
    END MENU

    @ 10, 190 MYBUTTON Test       ;
         OF Form_1                ;
         WIDTH  160               ;
         HEIGHT 64                ;
         CAPTION 'Custom Button'  ;
         ACTION MsgInfo('Click! 1') ;
         MULTILINE


    @ 80, 190 MYBUTTON Test2      ;
         OF Form_1                ;
         WIDTH  160               ;
         HEIGHT 64                ;
         CAPTION 'Button 2'  ;
         ACTION MsgInfo('Click! 2') ;
         MULTILINE

END WINDOW

   InstallEventHandler( "ButtonEvHandler" )

CENTER WINDOW Form_1
ACTIVATE WINDOW Form_1
Return Nil

FUNCTION ButtonEvHandler( nHWnd, nMsg, nWParam, nLParam )

LOCAL HWnd     := nHWnd
LOCAL Msg      := nMsg
LOCAL WParam   := nWParam
LOCAL LParam   := nLParam
LOCAL cControl, cForm
LOCAL nID, nForm := GetFormHandle( "Form_1" )

   IF nHWnd == nForm // Form_1.Handle
      IF nMsg == 43                                                   // WM_DRAWITEM
*         IF (nWParam >= IDC_BTN_1) .and. (nWParam <= IDC_BTN_5)
            nID := GetDlgCtrlID(GetFocus())
*           GetControlNameByHandle( nHWnd, @cControl, @cForm )
            OLAB_Draw( nHWnd, nID, nLParam )
            RETURN 1
*         ENDIF
      ENDIF
   ENDIF

RETURN NIL

FUNCTION OLAB_Draw( nHParent, nID, nDRAWITEMSTRUCT )
LOCAL cForm  := GetFormNameByIndex( GetFormIndexByHandle( nHParent ) )
LOCAL nShape := 10        // OLAB_Shape( cForm, nID )
LOCAL aColor := MyColor() // OLAB_Color( cForm, nID )
LOCAL aFont  := { "Arial", 9, .T., .F., .F., .F. }  // OLAB_Font( cForm, nID )
//  LOCAL MyControl := GetControlHandle( cObj, cForm )
//  LOCAL MyControl := OLAB_Handle( cForm, nID )

   OwnButtonDraw( nDRAWITEMSTRUCT, nShape, aColor[ 1 ], aColor[ 2 ], aColor[ 3 ], aFont )

RETURN NIL

FUNCTION MyColor()
LOCAL aBtnColor  := {}
LOCAL aDummy     := {}
LOCAL aColor     := {56,56,56}
LOCAL aGradient  := {192,192,192}

   // normal
   AADD( aDummy, RGBfromArray( YELLOW   ) )  // Text
   AADD( aDummy, RGBfromArray( aColor ) )  // backgound
   AADD( aDummy, RGBfromArray( BLACK  ) )  // frame
   AADD( aDummy, RGBfromArray( aGradient ) )  // 2nd Gradient Color
   AADD( aBtnColor, ACLONE( aDummy ) )

   // (pDIS->itemState & ODS_DISABLED)
   aDummy := {}                            // normal
   AADD( aDummy, RGBfromArray( GRAY   ) )  // Text
   AADD( aDummy, RGBfromArray( aColor ) )  // backgound
   AADD( aDummy, RGBfromArray( BLACK  ) )  // frame
   AADD( aDummy, RGBfromArray( GRAY   ) )  // 2nd Gradient Color
   AADD( aBtnColor, ACLONE( aDummy ) )

   // (pDIS->itemState & ODS_FOCUS)
   aDummy := {}                            // hm ...
   AADD( aDummy, RGBfromArray( BLACK  ) )  // Text
   AADD( aDummy, RGBfromArray( RED    ) )  // backgound
   AADD( aDummy, RGBfromArray( BLACK  ) )  // frame
   AADD( aDummy, RGBfromArray( WHITE  ) )  // 2nd Gradient Color
   AADD( aBtnColor, ACLONE( aDummy ) )

RETURN aBtnColor

FUNCTION RGBfromArray( aRGB )
RETURN RGB( aRGB[ 1 ], aRGB[ 2 ], aRGB[ 3 ] )

*
*
*