﻿/*
   MyButton user functions
   Added Width and Height by Pablo César
*/

#define CTRL_TYPE           1
#define CTRL_NAME           2
#define CTRL_HANDLE         3
#define CTRL_PARENT_HANDLE  4
#define CTRL_PROCEDURE      6
#define CTRL_DELETE_STATUS  13
#define WM_COMMAND          0x0111
#define BN_CLICKED          0
#define USR_COMP_PROC_FLAG  63

*------------------------------------------------------------------------------*
Init Procedure _InitMyButton
*------------------------------------------------------------------------------*

    InstallEventHandler ( 'MyButtonEventHandler' )
    InstallMethodHandler ( 'SetFocus' , 'MyButtonSetFocus' )
    InstallMethodHandler ( 'Enable' , 'MyButtonEnable' )
    InstallMethodHandler ( 'Disable' , 'MyButtonDisable' )
    InstallPropertyHandler ( 'Handle' , 'SetMyButtonHandle' , 'GetMyButtonHandle' )
    InstallPropertyHandler ( 'Caption' , 'SetMyButtonCaption' , 'GetMyButtonCaption' )

Return

*------------------------------------------------------------------------------*
Procedure _DefineMyButton ( cName , nRow , nCol , nWidth, nHeight , cCaption , bAction , cParent, lMultiline )
*------------------------------------------------------------------------------*
Local nControlHandle,nId,nParentFormHandle,k,cMacroVar

    If .Not. _IsWindowDefined (cParent)
        MsgHMGError("Window: "+ cParent + " is not defined.")
    Endif

    If _IsControlDefined (cName,cParent)
        MsgHMGError ("Control: " + cName + " Of " + cParent + " Already defined.")
    Endif

    cMacroVar := '_' + cParent + '_' + cName
    k           := _GetControlFree()
    nId         := _GetId()
    nParentFormHandle   := GetFormHandle (cParent)
    nControlHandle      := InitMyButton ( nParentFormHandle , ;
                                          nRow , ;
                                          nCol , ;
                                          cCaption , ;
                                          nId, ;
                                          nWidth, ;
                                          nHeight, ;
                                   lMultiline )

    Public &cMacroVar. := k

    _HMG_SYSDATA [ CTRL_TYPE ]          [k] := 'MYBUTTON'
    _HMG_SYSDATA [ CTRL_NAME ]          [k] := cName
    _HMG_SYSDATA [ CTRL_HANDLE ]        [k] := nControlHandle
    _HMG_SYSDATA [ CTRL_PARENT_HANDLE ] [k] := nParentFormHandle
    _HMG_SYSDATA [ 5 ]                  [k] := NIL
    _HMG_SYSDATA [ CTRL_PROCEDURE ]     [k] := bAction
    _HMG_SYSDATA [ 7 ]                  [k] := NIL
    _HMG_SYSDATA [ 8 ]                  [k] := NIL
    _HMG_SYSDATA [ 9 ]                  [k] := NIL
    _HMG_SYSDATA [ 10 ]                 [k] := NIL
    _HMG_SYSDATA [ 11 ]                 [k] := NIL
    _HMG_SYSDATA [ 12 ]                 [k] := NIL
    _HMG_SYSDATA [ CTRL_DELETE_STATUS ] [k] := .F.
    _HMG_SYSDATA [ 14 ]                 [k] := NIL
    _HMG_SYSDATA [ 15 ]                 [k] := NIL
    _HMG_SYSDATA [ 16 ]                 [k] := NIL
    _HMG_SYSDATA [ 17 ]                 [k] := NIL
    _HMG_SYSDATA [ 18 ]                 [k] := NIL
    _HMG_SYSDATA [ 19 ]                 [k] := NIL
    _HMG_SYSDATA [ 20 ]                 [k] := nWidth
    _HMG_SYSDATA [ 21 ]                 [k] := nHeight
    _HMG_SYSDATA [ 22 ]                 [k] := NIL
    _HMG_SYSDATA [ 23 ]                 [k] := NIL
    _HMG_SYSDATA [ 24 ]                 [k] := NIL
    _HMG_SYSDATA [ 25 ]                 [k] := NIL
    _HMG_SYSDATA [ 26 ]                 [k] := NIL
    _HMG_SYSDATA [ 27 ]                 [k] := NIL
    _HMG_SYSDATA [ 28 ]                 [k] := NIL
    _HMG_SYSDATA [ 29 ]                 [k] := NIL
    _HMG_SYSDATA [ 30 ]                 [k] := NIL
    _HMG_SYSDATA [ 31 ]                 [k] := NIL
    _HMG_SYSDATA [ 32 ]                 [k] := NIL
    _HMG_SYSDATA [ 33 ]                 [k] := NIL
    _HMG_SYSDATA [ 34 ]                 [k] := NIL
    _HMG_SYSDATA [ 35 ]                 [k] := NIL
    _HMG_SYSDATA [ 36 ]                 [k] := NIL
    _HMG_SYSDATA [ 37 ]                 [k] := NIL
    _HMG_SYSDATA [ 38 ]                 [k] := NIL
    _HMG_SYSDATA [ 39 ]                 [k] := NIL
    _HMG_SYSDATA [ 40 ]                 [k] := NIL

Return

*------------------------------------------------------------------------------*
Function MyButtonEventhandler ( hWnd, nMsg, wParam, lParam )
*------------------------------------------------------------------------------*
Local i
Local RetVal := Nil

If nMsg == WM_COMMAND

    i := Ascan ( _HMG_SYSDATA [ CTRL_HANDLE ] , lParam )

    If i > 0

        IF HiWord (wParam) == BN_CLICKED
            RetVal := 0
            _DoControlEventProcedure ( _HMG_SYSDATA [CTRL_PROCEDURE] [i] , i )
        Endif

    Endif

Endif
Return RetVal


*------------------------------------------------------------------------------*
Procedure MyButtonSetFocus ( cWindow , cControl )
*------------------------------------------------------------------------------*
Local i

    If GetControlType ( cControl , cWindow ) == 'MYBUTTON'

        SetFocus ( GetControlHandle ( cControl , cWindow ) )

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .T.

    else

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .F.

    endif

Return

*------------------------------------------------------------------------------*
Procedure MyButtonEnable ( cWindow , cControl )
*------------------------------------------------------------------------------*
Local i

    If GetControlType ( cControl , cWindow ) == 'MYBUTTON'

        EnableWindow ( GetControlHandle ( cControl , cWindow ) )

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .T.

    else

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .F.

    endif

Return

*------------------------------------------------------------------------------*
Procedure MyButtonDisable ( cWindow , cControl )
*------------------------------------------------------------------------------*
Local i

    If GetControlType ( cControl , cWindow ) == 'MYBUTTON'

        DisableWindow ( GetControlHandle ( cControl , cWindow ) )

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .T.

    else

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .F.

    endif

Return

*------------------------------------------------------------------------------*
Function SetMyButtonHandle ( cWindow , cControl )
*------------------------------------------------------------------------------*

    If GetControlType ( cControl , cWindow ) == 'MYBUTTON'

        MsgExclamation ( 'MyButton can not change its handle !', 'This Property is Read Only' )

    endif

    _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .F.

Return Nil

*------------------------------------------------------------------------------*
Function GetMyButtonHandle ( cWindow , cControl )
*------------------------------------------------------------------------------*
Local RetVal := Nil

    If GetControlType ( cControl , cWindow ) == 'MYBUTTON'

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .T.
        RetVal := GetControlHandle ( cControl , cWindow )

    else

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .F.

    endif

Return RetVal

*------------------------------------------------------------------------------*
Function SetMyButtonCaption ( cWindow , cControl , cProperty , cValue )
*------------------------------------------------------------------------------*

    If GetControlType ( cControl , cWindow ) == 'MYBUTTON'

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .T.

        SetWindowText ( GetControlHandle ( cControl , cWindow ) , cValue )

    else

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .F.

    endif

Return Nil

*------------------------------------------------------------------------------*
Function GetMyButtonCaption ( cWindow , cControl )
*------------------------------------------------------------------------------*
Local RetVal := Nil

    If GetControlType ( cControl , cWindow ) == 'MYBUTTON'

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .T.

        RetVal := GetWindowText ( GetControlHandle ( cControl , cWindow ) )

    else

        _HMG_SYSDATA [USR_COMP_PROC_FLAG] := .F.

    endif

Return RetVal


*------------------------------------------------------------------------------*
* Low Level C Routines
*------------------------------------------------------------------------------*

#pragma BEGINDUMP

//  #include "SET_COMPILE_HMG_UNICODE.ch"
//  #include "HMG_UNICODE.h"
#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HBRUSH LinearGradientBrush( HDC pDC, long cx, long cy, COLORREF crFrom, COLORREF crTo, BOOL bVert )
{
   HDC     memDC;
   HBITMAP memBmp;
   HBRUSH  pGradientBrush = ( HBRUSH ) NULL;

   memDC  = CreateCompatibleDC( pDC );
   memBmp = CreateCompatibleBitmap( pDC, cx, cy );

   if( memDC && memBmp )
   {
      TRIVERTEX     rcVertex[ 3 ];
      GRADIENT_RECT gRect;

      rcVertex[ 0 ].x     = 0;
      rcVertex[ 0 ].y     = 0;
      rcVertex[ 0 ].Red   = ( unsigned short ) ( GetRValue( crFrom ) << 8 );
      rcVertex[ 0 ].Green = ( unsigned short ) ( GetGValue( crFrom ) << 8 );
      rcVertex[ 0 ].Blue  = ( unsigned short ) ( GetBValue( crFrom ) << 8 );
      rcVertex[ 0 ].Alpha = 0;

      rcVertex[ 1 ].x     = cx;
      rcVertex[ 1 ].y     = cy;
      rcVertex[ 1 ].Red   = ( unsigned short ) ( GetRValue( crTo ) << 8 );
      rcVertex[ 1 ].Green = ( unsigned short ) ( GetGValue( crTo ) << 8 );
      rcVertex[ 1 ].Blue  = ( unsigned short ) ( GetBValue( crTo ) << 8 );
      rcVertex[ 1 ].Alpha = 0;

      rcVertex[ 2 ].x     = cx;
      rcVertex[ 2 ].y     = cy;
      rcVertex[ 2 ].Red   = ( unsigned short ) ( GetRValue( crFrom ) << 8 );
      rcVertex[ 2 ].Green = ( unsigned short ) ( GetGValue( crFrom ) << 8 );
      rcVertex[ 2 ].Blue  = ( unsigned short ) ( GetBValue( crFrom ) << 8 );
      rcVertex[ 2 ].Alpha = 0;

      gRect.UpperLeft  = 0;
      gRect.LowerRight = 1;

      SelectObject( memDC, memBmp );

      GdiGradientFill( memDC, rcVertex, 3, &gRect, 2, bVert ? GRADIENT_FILL_RECT_V : GRADIENT_FILL_RECT_H );
//    GdiGradientFill( memDC, rcVertex, 3, &gRect, 3, bVert ? GRADIENT_FILL_TRIANGLE : GRADIENT_FILL_TRIANGLE );

      pGradientBrush = CreatePatternBrush( memBmp );

      DeleteObject( memBmp );
      DeleteObject( memDC );
   }

   return pGradientBrush;
}

// InitMyButton ( nParentFormHandle , ;
//                   nRow , ;
//                   nCol , ;
//                   cCaption , ;
//                   nId, ;
//                   nWidth, ;
//                   nHeight, ;
//                   lMultiline )

HB_FUNC( INITMYBUTTON )
{
    HWND hwnd = (HWND) hb_parnl (1) ;
    HWND hbutton;
    INT  Style;

   // Style = WS_CHILD | BS_PUSHBUTTON | WS_VISIBLE | BS_OWNERDRAW ;
   Style = BS_NOTIFY | WS_CHILD | BS_PUSHBUTTON | WS_VISIBLE | BS_OWNERDRAW  ;

   if( hb_parl( 8 ) )
      Style = Style | BS_MULTILINE ;

    hbutton = CreateWindowEx( 0, "button" ,
                           hb_parc(4) ,
                           Style ,
                           hb_parni(3) ,
                           hb_parni(2) ,
                           hb_parni(6) ,
                           hb_parni(7) ,
                           hwnd ,
                           (HMENU)hb_parni(5) ,
                           GetModuleHandle(NULL) ,
                           NULL ) ;

//    SetWindowTheme(hButton,CHR(0),CHR(0))

    hb_retnl ( (LONG) hbutton );
}

//               1                2       3        4        5        6
// OwnButtonDraw(nDRAWITEMSTRUCT, nShape, aColor1, aColor2, aColor3, aFont)
HB_FUNC( OWNBUTTONDRAW )
  {
    DRAWITEMSTRUCT *pDIS = (DRAWITEMSTRUCT *) hb_parnl(1);

    INT nShape = (INT) hb_parni(2);

    TCHAR *FontName  = (TCHAR *) hb_parvc(6, 1);
    INT   nFontSize  = (INT)     hb_parvni(6, 2);
    INT   nBold      = hb_parvl(6, 3) ? FW_BOLD : FW_NORMAL;
    INT   nItalic    = hb_parvl(6, 4) ? 1 : 0;
    INT   nUnderline = hb_parvl(6, 5) ? 1 : 0;
    INT   nStrikeOut = hb_parvl(6, 6) ? 1 : 0;

    COLORREF TextColor;
    COLORREF BackColor;
    COLORREF FrameColor;
    COLORREF FrameColor2 = 0xFFFFFFFF;
    COLORREF GradientColor = 0x80808080;
    HBRUSH   hBrush;
    HBRUSH   hBrush2;
    HBRUSH   hBrushOld;
    HPEN     hPen;
    HPEN     hPenOld;
    HFONT    hFont;
    HFONT    hFontOld;
    RECT     rcText;
    INT      nTextH;

    INT nTextLen = GetWindowTextLength(pDIS->hwndItem) + 1;
    TCHAR *Text  = (TCHAR *) hb_xgrab(nTextLen * sizeof(TCHAR));
    GetWindowText(pDIS->hwndItem, Text, nTextLen);

    if (pDIS->itemState & ODS_DISABLED)
    {
      TextColor  = (COLORREF) hb_parvni(4, 1);   // aColor2
      BackColor  = (COLORREF) hb_parvni(4, 2);
      FrameColor = (COLORREF) hb_parvni(4, 3);
      GradientColor = (COLORREF) hb_parvni(4, 4);
    }
 //   else if (pDIS->itemState & ODS_HOTLIGHT)
 //   {
 //     TextColor   = (COLORREF) hb_parvni(5, 1);  // aColor3
 //     BackColor   = (COLORREF) hb_parvni(5, 2);
 //     FrameColor  = (COLORREF) hb_parvni(3, 3);
 //     FrameColor2 = (COLORREF) hb_parvni(5, 3);
 //     GradientColor = (COLORREF) hb_parvni(5, 4);
 //   }
    else if (pDIS->itemState & ODS_SELECTED)
    {
      TextColor   = (COLORREF) hb_parvni(5, 1);  // aColor3
      BackColor   = (COLORREF) hb_parvni(5, 2);
      FrameColor  = (COLORREF) hb_parvni(3, 3);
      FrameColor2 = (COLORREF) hb_parvni(5, 3);
      GradientColor = (COLORREF) hb_parvni(5, 4);
    }
//    else if (pDIS->itemState & ODS_FOCUS)
//    {
//      TextColor   = (COLORREF) hb_parvni(5, 1);
//      BackColor   = (COLORREF) hb_parvni(5, 2);
//      FrameColor  = (COLORREF) hb_parvni(3, 3);
//      FrameColor2 = (COLORREF) hb_parvni(5, 3);
//      GradientColor = (COLORREF) hb_parvni(5, 4);
//    }
    else
    {
      TextColor  = (COLORREF) hb_parvni(3, 1);   // aColor1
      BackColor  = (COLORREF) hb_parvni(3, 2);
      FrameColor = (COLORREF) hb_parvni(3, 3);
      GradientColor = (COLORREF) hb_parvni(3, 4);
    }

    rcText.left   = pDIS->rcItem.left;
    rcText.top    = pDIS->rcItem.top ;
    rcText.right  = pDIS->rcItem.right;
    rcText.bottom = pDIS->rcItem.bottom;

//    hBrush = CreateSolidBrush(BackColor);
    hBrush = LinearGradientBrush(pDIS->hDC,(rcText.right-rcText.left),(rcText.bottom-rcText.top),BackColor,GradientColor,FALSE);
    hPen   = CreatePen(PS_INSIDEFRAME, 1, FrameColor);
    hFont  = CreateFont(-MulDiv(nFontSize, GetDeviceCaps(pDIS->hDC, LOGPIXELSY), 72), 0, 0, 0, nBold, nItalic, nUnderline, nStrikeOut, DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, FontName);

    hBrushOld = SelectObject(pDIS->hDC, hBrush);
    hPenOld   = SelectObject(pDIS->hDC, hPen);
    hFontOld  = SelectObject(pDIS->hDC, hFont);

    SetTextColor(pDIS->hDC, TextColor);
    SetBkColor(pDIS->hDC,   BackColor);
    SetBkMode( pDIS->hDC, TRANSPARENT);

    if (nShape >= 0)
    {
      if (FrameColor2 <= 0xFFFFFF)
      {
        hBrush2 = CreateSolidBrush(FrameColor2);
        SelectObject(pDIS->hDC, hBrush2);

        RoundRect(pDIS->hDC, pDIS->rcItem.left, pDIS->rcItem.top, pDIS->rcItem.right, pDIS->rcItem.bottom, nShape, nShape);

        SelectObject(pDIS->hDC, hBrush);
        DeleteObject(hBrush2);

        RoundRect(pDIS->hDC, pDIS->rcItem.left + 2, pDIS->rcItem.top + 2, pDIS->rcItem.right - 2, pDIS->rcItem.bottom - 2, nShape, nShape);
      }
      else
        RoundRect(pDIS->hDC, pDIS->rcItem.left, pDIS->rcItem.top, pDIS->rcItem.right, pDIS->rcItem.bottom, nShape, nShape);
    }
    else
    {
      if (FrameColor2 <= 0xFFFFFF)
      {
        hBrush2 = CreateSolidBrush(FrameColor2);
        SelectObject(pDIS->hDC, hBrush2);

        Ellipse(pDIS->hDC, pDIS->rcItem.left, pDIS->rcItem.top, pDIS->rcItem.right, pDIS->rcItem.bottom);

        SelectObject(pDIS->hDC, hBrush);
        DeleteObject(hBrush2);

        Ellipse(pDIS->hDC, pDIS->rcItem.left + 2, pDIS->rcItem.top + 2, pDIS->rcItem.right - 2, pDIS->rcItem.bottom - 2);
      }
      else
        Ellipse(pDIS->hDC, pDIS->rcItem.left, pDIS->rcItem.top, pDIS->rcItem.right, pDIS->rcItem.bottom);
    }

    nTextH = DrawText(pDIS->hDC, Text, -1, &rcText, DT_CALCRECT | DT_NOCLIP);

    rcText.left  = pDIS->rcItem.left  + 3;
    rcText.right = pDIS->rcItem.right - 3;

    if (nTextH < (pDIS->rcItem.bottom - pDIS->rcItem.top - 2 * 3))
    {
      rcText.top    = (pDIS->rcItem.bottom - pDIS->rcItem.top - nTextH) / 2;
      rcText.bottom = rcText.top + nTextH;
    }
    else
    {
      rcText.top    = pDIS->rcItem.top    + 3;
      rcText.bottom = pDIS->rcItem.bottom - 3;
    }

    DrawText(pDIS->hDC, Text, -1, &rcText, DT_CENTER);

    SelectObject(pDIS->hDC, hBrushOld);
    SelectObject(pDIS->hDC, hPenOld);
    SelectObject(pDIS->hDC, hFontOld);

    DeleteObject(hBrush);
    DeleteObject(hPen);
    DeleteObject(hFont);
    hb_xfree(Text);
  }

#pragma ENDDUMP
